using System.Text.Json;
using System.Text.Json.Serialization;

namespace View_by_Distance.Shared.Models;

public record GenealogicalDataCommunication(DateTime? Birth,
                                            DateTime? Changed,
                                            DateTime? Death,
                                            string? GivenName,
                                            string? Id,
                                            string? Name,
                                            string NickName,
                                            char Sex,
                                            string? Suffix,
                                            string? SurName,
                                            string? UId)
{

    public override string ToString()
    {
        string result = JsonSerializer.Serialize(this, GenealogicalDataCommunicationSourceGenerationContext.Default.GenealogicalDataCommunication);
        return result;
    }

}

[JsonSourceGenerationOptions(WriteIndented = true, DefaultIgnoreCondition = JsonIgnoreCondition.WhenWritingNull)]
[JsonSerializable(typeof(GenealogicalDataCommunication))]
internal partial class GenealogicalDataCommunicationSourceGenerationContext : JsonSerializerContext
{
}

[JsonSourceGenerationOptions(WriteIndented = true, DefaultIgnoreCondition = JsonIgnoreCondition.WhenWritingNull)]
[JsonSerializable(typeof(GenealogicalDataCommunication[]))]
internal partial class GenealogicalDataCommunicationSourceCollectionGenerationContext : JsonSerializerContext
{
}